#!/usr/bin/python
import glob, pickle, subprocess, sys, time

path = '.Deluge_data.txt'
path2 = '/home/USERNAME/.config/deluge/state/' #Replace USERNAME with your username

try:	argument = sys.argv[1]
except:	argument = 'void'

def main ():
	if (argument == '--start') or (argument == '-s'):
		original = load(path)	#load original number
		subprocess.Popen('deluge-gtk')
		time.sleep(5)		#wait for Execute plugin to execute scripts
		save(original)		#restore the original number, makes up for the Execute plugin bug.
		value = 0
	elif (argument == '--decrease') or (argument == '-d'):
		value = -1
	else:	value = 1

	save(adjust(value))
	return 0

def save(value):
	file = open(path, 'w')
	pickle.dump(value, file)
	file.close()
	return 0

def adjust(value):
	torrents = len(glob.glob1(path2,"*.torrent"))
	integervalue = load(path) + value
	if integervalue < 0:		integervalue = 0		#restrict the range
	if integervalue > torrents:	integervalue = torrents
	return integervalue

def load(path):
    try:
	unpicklefile = open(path, 'r')
	data = pickle.load(unpicklefile)
	unpicklefile.close()
    except:
	data = 0
    return data

if __name__ == "__main__":    main()
